# Bezpečnost sítí a služeb

11.2.2020


## 1. (Ne)Bezpečnost 2019

Radoslav Bodó, Jakub Urbanec


### Fyzická bezpečnost

- Rubber Duck
    - Klávesnice v USB + "program"
    - 10+ let stará věc

- Smart TV
    - Přes IR remote
    - Instalace aplikací (z neznámého zdroje)
    - Proč?
        - Mikrofon, kamera: Odposlech
        - Reproduktor: smrtelný v kombinaci Home assistantu

- Home assistant
    - Mikrofony, které se dají ovládat laserem
    - Až 100+ metrů


### Case study

- Webový .NET frontend pro git Bonobo
- *Mass assignment*
    - Zranitelnost pokročilých frameworků
    - „Flag” `isAdmin` nebo podobně
    - Může se propašovat do systému (povýšit session na admina)


### PGP/GPG - Keyservery

- Jednoduchý design
- Přidat klíč, nalézt klíč
- Synchronizace mezi servery
- Přidání podpisu ke klíči
- Koncept: keyservery nemažou klíče
- DoS útok na klíče s extrémním množstvím podpisů
    - GPG import trvá desítky minut a nakonec selže


### CPU fails 2019

- Microarchitectural Data Sampling data
    - Útočník může vyčíst paměť, které mu nepatří
    - Nemůže si vybrat, co se přečte, ale je možné se dívat jinému procesoru
      „pod ruce”, co a s čím počítá
    - V cloudu a hostingu smrtelné

- I další HW útoky
    - TPM fail: Časové postranní kanály
    - Síťové karty s přímým přístupem do paměti či cache

- Obrana
    - Výměna HW, výměna designu 🙃
    - Lepení za pomocí SW
        - Např. šifrovat klíče v paměti


### RIPlace it

- Pokus Microsoft Windows o ochranu proti ransomware
    - Jde obejít pomocí DOS jmen souborů/linků
    - ¯\\_(ツ)_/¯

> „Co je to Disketa?”  
> „To je 3D reprezentace toho *Save* tlačítka”


### Chmatácká databáze

- MySQL má „feature” `LOAD DATA`, která umožňuje nahrát soubor do tabulky
- Existuje i varianta `LOCAL`, která
- Dá se zkombinovat s adminerem, přes který se pak v DB doptá na pěkný soubor
  vzdáleně u klienta
- Též může fiktivní MySQL server krást soubory z připojených klientů


### sudo

- `UID -1 != root`, ale je
- Buffer overflow v `pwfeedback`


### Fikanost roku

- Slovenské EET E-kasa
- Chráněné Datové Ulozisko (např. pro offline)
    - Od jednoho výrobce
    - Když kasa komunikuje s ChDU, tak má výjimku a *nešifruje*
    - ¯\\_(ツ)_/¯


### Závěr

Co s tím?

> Donutit lidi dělat svoji práci správně a pořádně.


## 2. Wi-Fi: Evoluce a zabezpečení


Michal Kostěnec, Martin Kylián

- WEP
    - 1997 vznik algoritmu
    - 1999 standard
    - RC4 a CRC-32, 2-way handshake
    - Na prolomení WEP stačí 40-80 tisíc IV, což lze získat v několika málo
      minutách

- WPA
    - Počítá s WPA2
    - Šifrování pomocí algoritmu MICHAEL, 4-way handshake
    - TKIP
        - Dynamická výměna klíčů
        - Suplicant: Démon pro správu klíčů
        - Při 2 chybách za minutu se přegenerují klíče
        - Jeden klíč má platnost cca hodinu

- WPA 2
    - 2004
    - AES-CCMP místo TKIP
    - Při odposlechnutí 4-way handshake je možné použít útok hrubou silou
        - Je možné deautentizovat libovolného klienta a vynutit handshake
        - Slovníkový útok
        - Umožní prolomit keystream a tak prolomit šifrovanou komunikaci

- Crackování hesel
    - cap2hccapx
    - johntheripper nebo hashcat
    - JohnTheRipper se standardním slovníkem a základními pravidly pro slabá hesla
        - `password.lst`

- WPS
    - Doplněk WPA 2
    - Provisioning: Přenese heslo k WPA2 do klienta
    - 8 číslic: PIN
        - Protokol vrací chybu v první/druhé půlce
        - Poslední číslice je kontrolní
        - Může trvat až několik vteřin na jeden pokus
        - Několik hodin na prolomení

    - Chyby v implementacích
        - Např. výrobce Ralink používá samé 0 pro seedy
        - PIN je pak možné získat za *vteřiny*

- WPA 2 enterprise
    - Používá se autentizační server
        - (P)EAP protocol na komunikaci klient-server
        - Autentizace serveru pomocí certifikátů
        - Self-signed certifikát je problém
        - Některé zařízení (starý Android) důvěřují libovolnému certifikátu
    - MSCHAPv2: Odchycení NTLM hashe
        - Prolamuje se lépe než PSK
    - Útoky MitM

- Roaming 802.11r
    - AP vysílají zahashované PSK do vzduchu
    - Útok hrubou silou...

- WPA 3
    - Módy šifrování
        - OWA: Opportunistic Wireless Encryption
        - SAE: Simultaneous Authentication of Equals
    - Používá se (EC)DH
    - Povinně podepsané management rámce
        - Nelze podvodně deautentizovat
    - Znemožňuje offline útoky
    - Útoky: Dragonblood
        - WPA 2 downgrade útok
        - DoS útok na AP


## 3. Certifikáty včera, dnes a zítra

Jan Chvojka

- Staré časy
    - HTML tag `<keygen>`
    - Certifikáty až 3 roky
    - EV měly zelený rámeček, všichni je chtěli

- Generování certifikátu v prohlížeči
    - JavaScript knihovna
    - Vygeneruje klíč a certifikát, pkcs#12 soubor na disku
    - Je třeba importovat do systému
    - Chránit soubor heslem

- Alternativní možnosti
    - OpenSSL, uživatelsky nepřívětivé
    - Nativní aplikace od CA
        - Post Signum, Sectigo
    - ACME

- Co řešit po vydání cetifikátu
    - CAA záznam
    - OCSP stapling
    - Monitoring CT log


## 4. WebAuthn

Jaroslav Bodó

- Expirace hesel
    - NIST doporučení: Nenutit uživatele měnit hesla
    - Je vhodné pro všechny?
- Aktuální možnosti přihlašování
    - Jméno + heslo
        - + 2FA
    - Klientské certifikáty
    - SSO provider

- WebAuthn: Nový hráč
    - Má potenciál nahradit heslo za fyzický token
        - U2F Token
        - TPM
        - Mobilní telefon
    - Na bázi kryptografie veřejného klíče
    - Oproti klientským TLS certifikátům je tato metoda uvnitř aplikace
      (JavaScript/backend)
- U2F ~= FIDO ~= WebAuthn


## 5. Budování RPKI

- Budování IRR databáze
    - Často dobrovolné
    - často zastaralé
    - Neexistuje centrální autorita
- Resource Public Key Infrastructure
    - Určuje certifikační autority – regionální registry
        - Se svými adresami (rozsahy)
    - Regionální registry rozdělují vlastní adresy
    - Síťový prvek (BGP) pak ověřují přijaté cesty/prefixy
