# IPv6: 10 let poté

6.6.2022


## Úvod

Ondřej Caletka


- Dle Google 40 % provozu po IPv6
- Dle IX pouze 4 %
- Nové sítě bez IPv6 🙁
    - Nordic Telecom
    - T-Mobile FttH
    - Starlink


## Nutnost přechodu na IPv6

Ondřej Caletka


- IPv6 již 10 let oficiálně spuštěna
    - Od té doby provoz roste, ale pomalu
    - IPv6 je občan druhé kategorie
- IPv4 došly v roce 2012
    - Čekací listina roste nade všechny meze
    - 900 LIRů čeká na /24 prefixy
    - Trh s adresami
- Není žádný plán C, IPv6 je jediný možný plán pro rozvoj Internetu

**Je potřeba unikátní IPv4 adresu?**
- CGNAT se zlepšuje, stále více koncových zařízení lze schovat za minimální
    množství IPv4 adres
- Provozovatelé housingu, hostingu, VPS apod. potřebují mraky adres
    - IP adresa je tak zásadní artikl pro provoz takových služeb
    - Kdo má více adres může více růst

**Výhody IPv6**
- Neomezený růst
- Menší zátěž pro CGNAT
- Méně problémů spojených se sdílením IPv4 adres
    - Block listy
    - Rate limiting (největší problém s NATovaným provozem – limit dotazů
        na Google a podobné služby)
- Jednodušší trasování adres a klientů
    - Není třeba sbírat mapování NAT flows
    - Celé mapování může být staticky
- Žádné problémy s kolizí privátních prefixů

**Jak s nasazováním IPv6**
- Začít s adresním plánem
    - Myslet na budoucnost, na reálný růst
- IPv6 by nemělo být závislé na IPv4
    - IPv4 se jednou vypne
- Přechodový mechanismus pro IPv4
    - Snáze se poté IPv4 vypne

**Proč nerozšířit IPv4**
- Každá úprava IPv4 znamená nekompatibilitu
- Koncová zařízení musí změnám rozumět
    - Vyžaduje aktualizaci SW
    - Rovnou tedy můžeme aktualizovat na IPv6-ready
- IPv6 počítá s veřejným očíslováním interních sítí (domácnost apod.)

**Bezpečnost**
- Není ani více ani méně bezpečná než IPv4
- Je to síťový protokol
- Veřejné adresy jsou strašák
    - *Umožňují* přímou komunikaci, neznamená to, že je to tak nutné
    - *V IPv4 není přímá komunikace možná*

**Budoucnost**
- Nasazení IPv6 je jen první krok
- Až s vypnutím IPv4 vyřešíme problém
- IPv6-only síť
    - Začít s management VLAN, domácí sítí apod.


## Proč je jeden lepší než dva

Radek Zajíc


- IPv6 RFC 1995-1999
- Přechodové mechanismy 1996
    - Dual stack
    - IPv6-only
- NAT-PT slepá větev 2000-2007
- NAT64 2008, DNS64 2011
- 464XLAT
    - Spolupráce koncových zařízení a ISP 64 přechodového mechanismu
    - OS překládá 4 to 6, ISP 6 to 4

- IPv6-only s přechodovým mechanismem je snazší na údržbu
    - Přístup z/do IPv6 světa nativní
    - Přístup z/do IPv4 s překladem
    - Nutnost přečíslovat sítě nulová
    - Kolize nenastanou
    - P2P spojení přes Internet je nativní
    - Adresní prostor pro virtuály, kontejnery je neomezený
