# Konference P2D2 2022

2.6.2022

14\. ročník


## PostgreSQL 15: A look at the Elephants Trunk

Magnus Hagander

- Upcoming PG, currently in Beta


### DBA and administration

- Dropped support for pre-9.2 (pg_restore, etc.)
- Dropped Python2 support in pl/python
- `public` role has no longer *create* permission in public schema by default
    - (It still keeps *usage* permission)
- Exclusive backup mode removed
    - Deprecated for a long time
    - Use *barman*, ...
- JSON logging
- Optional "security invoker" for views
- psql `\dconfig` to show server parameters


### SQL and developer

- Numeric
    - Negative scale
    - Scale greater precision (extra zeros)
- *Unique* constraint with `NULL` values
    - `UNIQUE NULLS NOT DISTINCT`
- SQL/JSON tables and queries
    - Same functionality as SQL
    - Now standardised and implemented
- `MERGE` (different than `ON CONFLICT`)
    - Very flexible, much more then "upsert" `ON CONFLICT`
    - "Joins" source with target
    - Like *patch* for data


### Backup and replication

- Logical replication
    - Publish all tables in schema
    - Publish with row and column filtering

- Base backups
    - New server-side compression
    - And client-side decompression

- Log archiving
    - With preloaded libraries
    - Shell scripts have overhead


### Performance

- LZ4 and zstd Compression
- Parallel query
    - Added DISTINCT queries


## BRIN improvements

Tomáš Vondra

- BTREE indexy
    - Záznamy v indexu jsou 1:1 s indexovanými daty
    - Vhodné pro dotazování na konkrétní hodnotu, na řazení
    - Mohou být relativně velké
    - Každý řádek z dat má 20+ B záznam v indexu
- BRIN indexy
    - Rozdělí tabulku na intervaly
    - Mapuje záznamy z indexu na intervaly (sekce) řádků tabulky
    - Řádově menší indexy
    - Pro optimální fungování potřebuje korelaci mezi daty a záznamy
        - Vhodné pro timestamps, sekvence, 2D GIS data, ...
        - UPDATEs ničí tuto korelaci

- Vylepšení v PG 14
    - Více intervalů pro jeden blok hodnot
    - *Bloom* indexy pro náhodná data
        - Využívají hashe
        - Fungují pouze pro porovnání, nikoliv rozsahy
        - Např. UUID, ...


## Logical replication in PG 15

Peter Eisentraut

- Row filter
    - `WHERE` condition applies
- Column selection
    - "Select" columns in publication
- Replicate all tables in a schema
    - Publication
- Skip erring transactions
    - `ALTER SIBSCRIPTION` based on `lsn`
- Deactivate failing subscriptions
- More stats in `pg_stat_*`
- Less superuser
    - Owner of subscription does not need to be superuser
    - Subscriptions observe table privileges


## psql

Pavel Stěhule

- Tipy
    - `\h` předpis SQL apod.
    - `\set` seznam parametrů
    - `AUTOCOMMIT off`
    - `ON_ERROR_ROLLBACK`
    - `\pset` formát výstupu
        - `null `
    - `\e` externí editor (vim ♡)
    - `\conninfo` - `whoami`
    - `\gexec` 💣

- Neinteraktivní režim
    - `-A` unalined output
    - `-t` tuples only
    - `-c '<...>'` kód
    - `-v ON_ERROR_STOP` -- konfigurační proměnné z commandline
    - `--csv` výstup v csv rovnou z příkazu

- Makra
    - Makro pro zkopírování do schránky FTW 💪
    - Skriptování (\if, \endif, ...)

- psql pager
    - `export PSQL_PAGER="pspg -b "`
    - Zamknutí sloupců
    - Řazení
    - `\o ~/pipe` s `pspg --stream ~/pipe` 😉
    - s `\watch` též 👍


## Izolace transakcí

Aleš Zelený

- Různé úrovně izolace transakcí
    - Read uncommited
    - Read commited
    - Repeatable read
        - Statický snapshot dat k okamžiku poté, co začne transakce
        - Nikoliv k okamžiku začátku transakce
    - Serializable
- Různé anomálie:
    - Dirty read
    - Non-repeatable read
    - Phantom read
    - Anomálie serializace

- Při *update* postgres zamyká řádky a čeká na dokončení transakce
    - Zámky 🎉
